<template>
  <div>
    <CustomSubHeader>
      <CBreadcrumb class="border-0 mb-0">{{ title }}</CBreadcrumb>
      <CButton size="sm" color="success" :to="{ name: 'admin-pieces-piece', params: { piece: 'new' } }" class="mr-auto"
        >افزودن</CButton
      >
    </CustomSubHeader>

    <CCard>
      <CCardHeader>
        <slot name="header">
          <CIcon name="cil-grid" />
          {{ list_title }}
        </slot>
      </CCardHeader>
      <CCardBody>
        <el-table :data="pieces" style="width: 100%">
          <el-table-column type="index" label="#"> </el-table-column>

          <el-table-column prop="name" label="نام قطعه" width=""> </el-table-column>

          <el-table-column prop="code" label="کد قطعه" width=""> </el-table-column>

          <el-table-column label="ویرایش" width="105" align="left">
            <template slot-scope="scope">
              <CButton
                :key="scope.row._id"
                color="warning"
                variant="outline"
                :to="{ name: 'admin-pieces-piece', params: { piece: scope.row._id } }"
              >
                <i class="fal fa-pencil"></i>
              </CButton>
              <CButton color="danger" variant="outline" @click="del(scope.row._id)">
                <i class="fal fa-trash-alt"></i>
              </CButton>
            </template>
          </el-table-column>
        </el-table>
      </CCardBody>
    </CCard>
  </div>
</template>

<script>
export default {
  name: 'AdminPiecesList',
  layout: 'admin',
  async asyncData({ $axios, error }) {
    try {
      const pieces = await $axios.get(`/api/admin/pieces`)
      return {
        pieces: pieces.data
      }
    } catch (err) {
      error({ status: 404, message: 'There is a problem here' })
    }
  },
  data() {
    return {
      title: 'لیست قطعات',
      list_title: 'لیست',
      pieces: null
    }
  },
  head() {
    return {
      title: this.title
    }
  },
  computed: {},
  methods: {
    del(id) {
      this.$confirm('این قطعه حذف شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .delete(`/api/admin/piece/${id}`)
            .then(response => {
              this.pieces = this.pieces.filter(item => item._id !== id)
              this.$message({
                type: 'success',
                message: 'قطعه حذف شد'
              })
            })
            .catch(err => {
              this.$message({
                type: 'error',
                message: err.response.data.message
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    }
  }
}
</script>
